﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Cursed
{
    public class Const
    {
        public const bool FullScreen = false;

        //if this is true, update is called from draw, rather than from XNA (lockstep forcing)
        public const bool UpdateWithDraw = true;

        public const float ViewSize = 12;
        public const float ActiveRegionBuffer = 12;

        //the smaller this is, the slower obj overlaps are resolved. smaller = smoother.
        public const float maxPush = 0.05f;
        //for collisions. 1 = elastic, 0 = inelastic. out of that range makes no sense.
        public const float RestitutionCoeff = 0f;

        //for quad-tree collision detection - the number of entities before a node splits
        public const int MaxQTChildren = 3;

        public const int PushIterations = 1;
        public const float PushFactor = 1f;

        //drawing orders
        public const float WandDepth = -50f;
        public const float SparkDepth = -50f;
        public const float DialogDepth = -49f;
        public const float AttackDepth = -2.0f;
        public const float DruidDepth = -1.3f;
        public const float DemonDepth = -1.0f;
        public const float FamiliarDepth = -1.2f;
        public const float WallDepth = -0.9f;
        public const float WoodDepth = -.4f;
        public const float DoorClosedDepth = -.1f;
        public const float LifeBlobDepth = -.3f;
        public const float SpawnDepth = -.2f;
        public const float FootSwitchDepth = -.1f;
        public const float ExitDepth = -.1f;
        public const float GroundDepth = 0f;
        public const float EntranceDepth = .1f;
        public const float DoorOpenDepth = .2f;

        //gob stuff
        public const float RescanTime = .1f;

        //druid stuff
        public const float LifeSpellAmount = .5f;
        public const float LifeSpellMana = .05f;
        public const float LifeSpellCoolDown = 0.2f;

        public const float WoodSpellMana = .05f;
        public const float WoodSpellCoolDown = 0.2f;

        public const float DruidRepoopTime = 0.1f;
        public const float DruidPoopDecay = 0.5f;
        public const float DruidPoopAmount = 0.2f;

        //demon stuff
        public const float DemonClawStrength = 0.25f;
        public const float DemonClawAttackDuration = .2f;
        public const float DemonClawAttackCoolDown = 0.5f;
        public const float DemonSpinStrength = 0.75f;
        public const float DemonSpinAttackDuration = .4f;
        public const float DemonSpinAttackCoolDown = 2f;

        public const float LungeCooldown = 2;
        public const float LungeDamageFactor = 3;

        public const float LifeBlobDrainRate = 3;

        //familiar AI
        public const float FamiliarEnergyVisibilityThreshold = -1;
    }
}
