﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.gob.tile;
using Cursed.gob.mob;
using System.Windows;
using Cursed.gob;
using Cursed.geom;
using Microsoft.Xna.Framework;

namespace Cursed.col
{
    public interface ICollider
    {
        void Clear();
        void HandleCollisions();
        void Update(GameTime gameTime);
        void AddMob(Mob mob);
        void RemoveMob(Mob mob);
        void AddTile(Tile tile);
        void RemoveTile(Tile tile);
        ICollection<Mob> MobsInBounds(Bounds bounds);
        ICollection<Gob> GobsInBounds(Bounds bounds);
        void CollectMobsInBounds(Bounds bounds, ICollection<Mob> pool);
        void CollectGobsInBounds(Bounds bounds, ICollection<Gob> pool);
        ICollection<Tile> TilesAt(int x, int y);
    }
}
