﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.input.ai;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Cursed.geom;
using Cursed.input;
using Cursed.view.renders;
using Cursed.sound;


namespace Cursed.gob.mob
{
    public class DialogMobInfo : MobInfo
    {
        public DialogMobInfo()
            :base()
        {
            Depth = Const.DialogDepth;
        }
        
        Mob target;

        public Mob Target
        {
            get { return target; }
            set { target = value; }
        }
        Line line;

        public Line Line
        {
            get { return line; }
            set { line = value; }
        }

    }
    public class DialogMob: Mob
    {
        float elapsedTime = 0;
        public DialogMob(CursedGame game, DialogMobInfo info)
        :base(game, info)
        {
            this.IsEffect = true;
            this.Transcendent = true;
        }
        public override void Load()
        {
            base.Load();
            this.clearRenders();
            DialogRenderInfo info = new DialogRenderInfo();
            info.Texture = CursedGame.textureLib.GetTexture("square");
            info.Mask = new Color(.6f, .6f, .6f, .3f);
            info.Line = DialogMobInfo.Line.Text;
            this.renderInfo = info;
            this.addRender(CursedGame.getRender(Render.RenderType.DialogRender),info);

        }
        public override void Update(GameTime gameTime)
        {
            ((DialogRenderInfo)renderInfo).Pos = DialogMobInfo.Target.Loc + new Vector2(0, DialogMobInfo.Target.MobInfo.Scale / .9f);
            elapsedTime += gameTime.ElapsedGameTime.Milliseconds*.001f;
            if (elapsedTime > DialogMobInfo.Line.Length)
            {
                CursedGame.RemoveGob(this);
            }
            this.shape = new Rect(CursedGame.Camera.Position, CursedGame.Camera.ScreenSize, CursedGame.Camera.ScreenSize);
        }
        public override void Draw(GameTime gameTime)
        {
            base.Draw(gameTime);
        }

        public DialogMobInfo DialogMobInfo
        {
            get { return (DialogMobInfo)info; }
        }
        public override void Unload()
        {
            base.Unload();
        }
    }
}
