﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Cursed.input;
using Cursed.gob.mob.kob;

namespace Cursed.gob.mob
{
    public class DialogTriggerZoneInfo : TriggerZoneInfo
    {
        int scene;

        public int Scene
        {
            get { return scene; }
            set { scene = value; }
        }
        public override Gob Create(CursedGame game)
        {
            return new DialogTriggerZone(game, this);
        }
    }
    
    public class DialogTriggerZone : TriggerZone, IControllable
    {
        public DialogTriggerZone(CursedGame game, DialogTriggerZoneInfo info)
            : base(game, info)
        {
            DialogController dInfo = new DialogController(game, info.Scene);
            game.AddController(dInfo);
            dInfo.Push(this);
        }
        public override void control(ControlInfo cInfo)
        {
            //this won't happen.
        }
        protected override bool canTrigger(Gob gob)
        {
            if (gob is Familiar)
                return base.canTrigger(gob);
            return false;
        }
        public override void Update(GameTime gameTime)
        {
            
            base.Update(gameTime);
        }
    }
}
