﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.geom;
using Microsoft.Xna.Framework;
using Cursed.view.renders;

namespace Cursed.gob.mob
{
    public class ObstructionInfo : MobInfo
    {
        public ObstructionInfo()
            : base()
        {
            Stuck = true;
            Depth = Const.WallDepth;
        }

        public override Gob Create(CursedGame game)
        {
            return new Obstruction(game, this);
        }
    }

    public class Obstruction : Mob
    {
        public Obstruction(CursedGame game, ObstructionInfo info)
            : base(game, info)
        {
            Transcendent = false;
            Inert = false;
            Transient = false;
            IsEffect = false;
        }

        public override void Load()
        {
            shape = new Circle(Vector2.Zero, .5f);
            renderInfo = new SpriteRenderInfo(new Cursed.geom.Bounds(GobInfo.DrawCenter, GobInfo.DrawWidth, GobInfo.DrawHeight));
            renderInfo.Texture = CursedGame.textureLib.GetTexture(GobInfo.Texture);
            addRender(CursedGame.getRender(Cursed.view.renders.Render.RenderType.SpriteRender), renderInfo);

            base.Load();
        }
    }
}
