﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Cursed.input.ai;

namespace Cursed.gob.mob.kob
{
    public class CraniumRatInfo : DemonInfo
    {
        public CraniumRatInfo()
            : base()
        {
            Scale = .5f;
            Thrust = 3;
            Mass = 0.2f;
        }

        public override Gob Create(CursedGame game)
        {
            return new CraniumRat(game, this);
        }
    }
    public class CraniumRat : Demon
    {
        public CraniumRat(CursedGame game, CraniumRatInfo info)
            : base(game, info)
        {

        }

        public override void Update(GameTime gameTime)
        {
            HashSet<Mob> additionalSeenMobs = new HashSet<Mob>();
            foreach (Mob mob in SeenMobs)
            {
                if (mob is CraniumRat)
                {
                    additionalSeenMobs.UnionWith(mob.SeenMobs);
                }
            }
            SeenMobs.UnionWith(additionalSeenMobs);
            base.Update(gameTime);
        }
    }
}
