﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.input.ai;
using Cursed.geom;
using Cursed.view.renders;
using Microsoft.Xna.Framework;
using Cursed.sound;
namespace Cursed.gob.mob.kob
{
    public class FamiliarInfo : DemonInfo
    {
        public FamiliarInfo()
            : base()
        {
            Thrust = 1;
            Drag = .25f;
            Depth = Const.FamiliarDepth;
            Mass = .1f;
            LungeDuration = 1;
            Label = "familiar";
        }

        public override Gob Create(CursedGame game)
        {
            return new Familiar(game, this);
        }
    }

    public class Familiar: Demon
    {
        protected Druid master;
        protected GreedyFamiliarControl familiarControl;

        public Familiar(CursedGame game, FamiliarInfo info)
            : base(game, info)
        {
            Transient = true;

            info.SpinAttack = true;
        }
        public override void Load()
        {
            base.Load();
            renderInfo.Mask = Microsoft.Xna.Framework.Graphics.Color.White;
            spinAttackSound = SoundIDs.FamiliarSpinAttack(CursedGame);

            SoundIDs.FamiliarSummon(CursedGame).play();
        }
        protected override void addControllers()
        {
            familiarControl = new GreedyFamiliarControl(this);
            CursedGame.AddController(familiarControl);
            /*
            LifeSeeker seekerControl = new LifeSeeker(this);
            CursedGame.AddController(seekerControl);
            seekerControl.Push(this);

            SpiritAttacker attackControl = new SpiritAttacker(this);
            CursedGame.AddController(attackControl);
            attackControl.Push(this);
             */ 
        }

        public override void Unload()
        {
            SoundIDs.FamiliarDismiss(CursedGame).play();
            CursedGame.RemoveController(familiarControl);
            base.Unload();
        }

        public Druid Master
        {
            get { return master; }
            set { master = value; }
        }

        public FamiliarInfo FamiliarInfo
        {
            get { return (FamiliarInfo)info; }
        }
        public override void updateColor()
        {
            
            return;
        }
    }
}
