﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using Cursed.view;
using System.Windows.Media;
using System.Windows;
using Cursed.input;
using System.Runtime.Serialization;
using Cursed.sound;


namespace Cursed.gob.mob.kob
{
    //====================
    //Killable Game Object
    //====================
    public class KobInfo : MobInfo
    {
        float currentHealth;
        float maxHealth;
        float energy;

        public KobInfo()
            : base()
        {
            currentHealth = 1;
            maxHealth = 1;
        }

        public float CurrentHealth
        {
            get { return currentHealth; }
            set { currentHealth = value; }
        }
        public float MaxHealth
        {
            get { return maxHealth; }
            set { maxHealth = value; }
        }
        public float Energy
        {
            get { return energy; }
            set { energy = value; }
        }
    }
    public class Kob : Mob
    {
        protected Sound hitSound;
        protected Sound deathSound;

        public Kob(CursedGame game, KobInfo info)
            : base(game, info)
        {
            hitSound = null;
        }
        public KobInfo KobInfo
        {
            get { return (KobInfo)info; }
        }

        public virtual void takeDamage(float damage)
        {

            KobInfo.CurrentHealth -= damage;
            if (KobInfo.CurrentHealth <= 0)
            {
                die();
            }
            else
            {
                if (hitSound != null)
                {
                    hitSound.stop();
                    hitSound.play();
                }
            }
        }
        public virtual void die()
        {
            if (deathSound != null)
            {
                deathSound.play();
            }
            CursedGame.RemoveGob(this);
        }
    }
}
