﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using System.Runtime.Serialization;

namespace Cursed.gob.tile
{
    public class GroundInfo : TileInfo
    {
        // the resistance this ground has to things walking over it
        float drag;
        // the purchase this ground provides to things walking over it
        float friction;

        public GroundInfo(int x, int y)
            : base(x, y)
        {
            drag = .1f;
            friction = 1;
            Depth = Const.GroundDepth;
            Texture = "StoneFloor";
            Mask = new Color(.7f, .7f, .7f, 1f);
        }

        public override Gob Create(CursedGame game)
        {
            return new Ground(game, this);
        }

        public float Drag
        {
            get { return drag; }
            set { drag = value; }
        }

        public float Friction
        {
            get { return friction; }
            set { friction = value; }
        }
    }
    public class Ground : Tile
    {
        public Ground(CursedGame game, GroundInfo info)
            : base(game, info)
        {
            Transcendent = true;
            Inert = true;
        }

        public override void Load()
        {
            base.Load();
            renderInfo.Mask = new Color(100, 100, 100);
        }

        public GroundInfo GroundInfo
        {
            get { return (GroundInfo)info; }
        }
    }
}
