﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Cursed.input
{
    public class ControlInfo
    {

    }


    public enum MouseType
    {
        None,
        Offensive,
        Defensive
    }

    public class MouseCursorInfo : ControlInfo
    {
        Vector2 mouse;
        bool clicked;
        bool modifier;
        MouseType type;

        public Vector2 Mouse
        {
            get { return mouse; }
            set { mouse = value; }
        }

        public bool Clicked
        {
            get { return clicked; }
            set { clicked = value; }
        }

        public bool Modifier
        {
            get { return modifier; }
            set { modifier = value; }
        }

        public MouseType Type
        {
            get { return type; }
            set { type = value; }
        }
    }

    public class MouseTrailInfo : ControlInfo
    {

        List<Vector2> trail;
        MouseType type;
        bool modifier;
        bool finished;

        public MouseTrailInfo()
        {
            trail = new List<Vector2>();
            type = MouseType.None;
            finished = false;
        }

        public List<Vector2> Trail
        {
            get { return trail; }
        }

        public MouseType Type
        {
            get { return type; }
            set { type = value; }
        }

        public bool Modifier
        {
            get { return modifier; }
            set { modifier = value; }
        }

        public bool Finished
        {
            get { return finished; }
            set { finished = value; }
        }
    }

    public class DirectionControlInfo : ControlInfo
    {
        Vector2 direction;

        public Vector2 Direction
        {
            get { return direction; }
            set { direction = value; }
        }
    }

    public class EscapeControlInfo : ControlInfo
    {

    }

    public class LungeInfo : ControlInfo
    {

    }

    public class BasicAttackInfo : ControlInfo
    {
        public enum ATTACKTYPE{NORMAL,SPIN,SLAM};
        Vector2 direction;
        ATTACKTYPE type;
        public BasicAttackInfo()
        {
            type = ATTACKTYPE.NORMAL;
        }
        public Vector2 Direction
        {
            get { return direction; }
            set { direction = value; }
        }
        public ATTACKTYPE Type
        {
            get{return type;}
            set { type = value; }
        }
    }

    public class TextInputInfo : ControlInfo
    {
        string textInput;
        string inProgress;
        List<string> lines;
        bool active;
        public string TextInput
        {
            get { return textInput; }
            set { textInput = value; }
        }
        public string InProgress
        {
            get { return inProgress; }
            set { inProgress = value; }
        }
        public List<string> Lines
        {
            get { return lines; }
            set { lines = value; }
        }
        public bool Active
        {
            get { return active; }
            set { active = value; }
        }
        int lineLimit;

        public int LineLimit
        {
            get { return lineLimit; }
            set { lineLimit = value; }
        }
    }
}
