﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.view;
using Microsoft.Xna.Framework;
using Cursed.input.util;

namespace Cursed.input
{
    public class GestureInfo : ControlInfo
    {
        WGesture gesture;
        MouseType type;
        public MouseType Type
        {
            get { return type; }
            set { type = value; }
        }

        public WGesture Gesture
        {
            get { return gesture; }
            set { gesture = value; }
        }
    }

    public class MouseGestureController : MouseTrailController
    {
        public MouseGestureController(ICamera camera, GameWindow window)
            : base(camera, window)
        {

        }

        public override void act(Microsoft.Xna.Framework.GameTime time)
        {
            updateTrail();
            if (trailInfo.Finished && trailInfo.Modifier)
            {
                //a gesture has  been completed, analyze it for segments
                GestureInfo gestureInfo = new GestureInfo();
                gestureInfo.Type = trailInfo.Type;

                List<Vector2> trail = new List<Vector2>();
                foreach (Vector2 loc in trailInfo.Trail)
                {
                    if (trail.Count == 0 || loc != trail[trail.Count - 1])
                        trail.Add(loc);
                }

                if (trail.Count < 2)
                    return;

                gestureInfo.Gesture = new WGesture(trail);

                if (Target != null)
                    Target.control(gestureInfo);
            }
            if (trailInfo.Finished)
                trailInfo = new MouseTrailInfo();
        }
    }
}
