﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Cursed.sound
{
    public abstract class Sound
    {
        protected SoundManager.PRIORITY pri;
        protected SoundEffectInstance current;
        public Sound()
        {
            this.pri = SoundManager.PRIORITY.MEDIUM;
        }
        public Sound(SoundManager.PRIORITY pri)
        {
            this.pri = pri;
        }
        public abstract void play();
        public abstract void stop();
        internal virtual void playSound()
        {
            current.Play();
        }
        internal virtual void stopSound()
        {
            current.Stop();
        }
        internal void pause()
        {
            current.Pause();
        }
        internal void resume()
        {
            current.Resume();
        }
        public abstract float Volume
        {
            get;
            set;
        }
        public SoundManager.PRIORITY Priority
        {
            get { return pri; }
            set { pri = value; }
        }
        internal bool isStopped()
        {
            return (current.State == SoundState.Stopped);
        }
    }
}
