﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Cursed.sound
{
    public class SoundIDs
    {
        public const string GuitarFalseE = "guitar\\false_harmonics_e";
        public const string GuitarFalseFs = "guitar\\false_harmonics_fs";
        public const string GuitarFalseGs = "guitar\\false_harmonics_gs";
        public const string GuitarFalseAs = "guitar\\false_harmonics_as";
        public const string Guitar1E = "guitar\\notes_1_e";
        public const string Guitar1Fs = "guitar\\notes_1_fs";
        public const string Guitar1Gs = "guitar\\notes_1_gs";
        public const string Guitar1As = "guitar\\notes_1_as";
        public const string GuitarHarmonics13 = "guitar\\harmonic_1_3";
        public const string GuitarHarmonics46 = "guitar\\harmonic_4_6";
        public const string GuitarSlideDown2 = "guitar\\slide_down_2";
        public const string GuitarSlideDown3 = "guitar\\slide_down_3";
        public const string GuitarSlideDown4 = "guitar\\slide_down_4";
        public const string GuitarHarm23_7 = "guitar\\harm_x3_23_7";
        public const string GuitarChord234_2 = "guitar\\chord234_2";
        public const string GuitarChord234_3 = "guitar\\chord234_3";
        public const string GuitarChord234_4 = "guitar\\chord234_4";
        public const string GuitarScritch4 = "guitar\\scritche4";
        public const string GuitarScritch5 = "guitar\\scritche5";
        public const string GuitarScritch6 = "guitar\\scritche6";
        public const string GuitarGolpe1 = "guitar\\golpe1";
        public const string GuitarGolpe2 = "guitar\\golpe2";
        public const string GuitarGolpe3 = "guitar\\golpe3";
        public const string GuitarGolpe4 = "guitar\\golpe4";
        public const string GuitarGolpe5 = "guitar\\golpe5";

        public static Sound LifeCast(CursedGame game)
        {
            string[] names = { GuitarChord234_2, GuitarChord234_3, GuitarChord234_4 };
            return new VariableSound(game.SoundBank, game.SoundManager, names, .25f, game.Random);
        }

        public static Sound WoodCast(CursedGame game)
        {
            string[] names = { GuitarScritch4, GuitarScritch5, GuitarScritch6 };
            return new VariableSound(game.SoundBank, game.SoundManager, names, .25f, game.Random);
        }

        public static Sound FamiliarSummon(CursedGame game)
        {
            return new SimpleSound(game.SoundBank, game.SoundManager, GuitarHarmonics13, 1);
        }
        public static Sound FamiliarDismiss(CursedGame game)
        {
            return new SimpleSound(game.SoundBank, game.SoundManager, GuitarHarmonics46, 1);
        }

        public static Sound FamiliarBasicAttack(CursedGame game)
        {
            string[] names = { GuitarFalseE, GuitarFalseFs, GuitarFalseGs, GuitarFalseAs };
            return new VariableSound(game.SoundBank, game.SoundManager, names, .25f, game.Random);
        }
        public static Sound FamiliarSpinAttack(CursedGame game)
        {
            return new SimpleSound(game.SoundBank, game.SoundManager, GuitarHarm23_7, 1);
        }
        public static Sound DemonHit(CursedGame game)
        {
            string[] names = { Guitar1E, Guitar1Fs, Guitar1Gs, Guitar1As };
            return new VariableSound(game.SoundBank, game.SoundManager, names, .25f, game.Random);
        }
        public static Sound DemonDeath(CursedGame game)
        {
            string[] names = { GuitarSlideDown2, GuitarSlideDown3, GuitarSlideDown4 };
            return new VariableSound(game.SoundBank, game.SoundManager, names, .5f, game.Random);
        }
        public static Sound DruidHit(CursedGame game)
        {
            string[] names = { GuitarGolpe1, GuitarGolpe2, GuitarGolpe3, GuitarGolpe4, GuitarGolpe5 };
            return new VariableSound(game.SoundBank, game.SoundManager, names, 1, game.Random);
        }
    }

}
