﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Cursed.sound
{
    public class SoundManager
    {
        public enum PRIORITY { LOWEST, LOW, MEDIUM, HIGH, HIGHEST };
        class Slot
        {
            public Slot(Sound val, SoundManager.PRIORITY pri)
            {
                this.val = val;
                this.index = pri;
            }
            public PRIORITY index;
            public Sound val;
        }
        private Slot[] list;
        private int count;
        public SoundManager()
        {
            list = new Slot[16];
            count = 0;
        }
        public SoundManager(int size)
        {
            list = new Slot[size];
            count = 0;
        }
        public bool addSound(Sound snd)
        {
            for (int i = 0; i < list.Length; i++)
            {
                if (list[i] == null)
                {
                    list[i] = new Slot(snd, snd.Priority);
                    snd.playSound();
                    return true;
                }
                if(list[i].index <= snd.Priority)
                {
                    Slot temp = list[i];
                    Slot next = null;
                    list[i] = new Slot(snd,snd.Priority);
                    for (int j = i + 1; j < list.Length; j++)
                    {
                        next = list[j];
                        list[j] = temp;
                        temp = next;
                    }
                    if (next != null && !next.val.isStopped())
                        next.val.stopSound();
                    snd.playSound();
                    return true;
                }
            }
            return false;
        }
        public bool removeSound(Sound snd)
        {
            for (int i = 0; i < count; i++)
            {
                if (list[i].val.Equals(snd))
                {
                    remove(i);
                    return true;
                }
            }
            return false;
        }
        public void update()
        {
            for(int i = 0;i<count; i++)
            {
                if (list[i].val.isStopped())
                {
                    remove(i);
                    i--;
                }
            }
        }
        private void remove(int index)
        {
            if (!list[index].val.isStopped())
                list[index].val.stopSound();
            list[index] = null;
            for (int i = index; i+1 < count; i++)
            {
                list[i] = list[i + 1];
                list[i + 1] = null;
            }
            count--;
        }
        public void pauseAll()
        {
            for (int i = 0; i < count; i++)
            {
                list[i].val.pause();
            }
        }
        public void resumeAll()
        {
            for (int i = 0; i < count; i++)
            {
                list[i].val.resume();
            }
        }
    }
}
