﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Cursed.sound
{
    class VariableSound : Sound
    {
        SoundEffectInstance[] sounds;
        SoundManager mngr;
        Random rnd;
        public VariableSound(SoundBank bank,SoundManager mngr, String[] filenames, Random rnd)
        {
            sounds = new SoundEffectInstance[filenames.Length];
            for (int i = 0; i < filenames.Length; i++)
            {
                sounds[i] = bank.getInstance(filenames[i]);
                sounds[i].Volume = 1f;
                sounds[i].IsLooped = false;
            }
            this.rnd = rnd;
            this.mngr = mngr;
        }
        public VariableSound(SoundBank bank,SoundManager mngr, String[] filenames, float volume, Random rnd)
        {
            sounds = new SoundEffectInstance[filenames.Length];
            for (int i = 0; i < filenames.Length; i++)
            {
                sounds[i] = bank.getInstance(filenames[i]);
                sounds[i].Volume = volume;
                sounds[i].IsLooped = false;
            }
            this.rnd = rnd;
            this.mngr = mngr;
        }
        public VariableSound(SoundBank bank, SoundManager mngr, String[] filenames, float volume, bool loop, Random rnd)
        {
            sounds = new SoundEffectInstance[filenames.Length];
            for (int i = 0; i < filenames.Length; i++)
            {
                sounds[i] = bank.getInstance(filenames[i]);
                sounds[i].Volume = volume;
                sounds[i].IsLooped = true;
            }
            this.rnd = rnd;
            this.mngr = mngr;
        }
        public override void play()
        {
            current = sounds[rnd.Next(sounds.Length)];

            mngr.addSound(this);
        }
        public override void stop()
        {
            mngr.removeSound(this);
        }
        public override float Volume
        {
            get
            {
                return current.Volume;
            }
            set
            {
                current.Volume = value;
            }
        }
    }
}
