﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.input;
using Cursed.gob.mob.kob;
using Cursed.gob;
using Cursed.gob.mob;
using Microsoft.Xna.Framework;
using Cursed.input.ai;

namespace Cursed.ui
{
    public class UIFamiliarInfo : FamiliarInfo
    {
        public UIFamiliarInfo()
            : base()
        {

        }

        public override Gob Create(CursedGame game)
        {
            return new UIFamiliar(game, this);
        }
    }

    public class UIFamiliar : Familiar
    {
        MouseTrailController mouseTrailController;
        MouseController mouseController;
        Wand wand;

        public UIFamiliar(CursedGame game, UIFamiliarInfo info)
            : base(game, info)
        {
            
        }

        public override void Load()
        {
            base.Load();

            WandInfo wandInfo = new WandInfo();
            wand = (Wand)wandInfo.Create(CursedGame);
            CursedGame.AddGob(wand);
        }

        public override void Unload()
        {
            CursedGame.RemoveController(mouseTrailController);
            CursedGame.RemoveController(mouseController);
            base.Unload();
        }

        protected override void addControllers()
        {
            mouseTrailController = new MouseTrailController(CursedGame.Camera, CursedGame.Window);
            mouseTrailController.Push(this);
            CursedGame.AddController(mouseTrailController);

            mouseController = new MouseController(CursedGame.Camera, CursedGame.Window);
            mouseController.Push(this);
            CursedGame.AddController(mouseController);

            familiarControl = new GreedyFamiliarControl(this);
            CursedGame.AddController(familiarControl);
        }

        #region IControllable Members

        public override void control(ControlInfo info)
        {
            if (info is MouseCursorInfo)
            {
                MouseCursorInfo mouseCursorInfo = (MouseCursorInfo)info;
                wand.GobInfo.Loc = mouseCursorInfo.Mouse;
            }
            if (info is MouseTrailInfo)
            {
                MouseTrailInfo mouseTrailInfo = (MouseTrailInfo)info;
                Vector2 loc = mouseTrailInfo.Trail[mouseTrailInfo.Trail.Count - 1];
                if (Ready)
                {
                    LifeBlobInfo lifeInfo = new LifeBlobInfo();
                    lifeInfo.Loc = loc;
                    lifeInfo.Amount = Const.LifeSpellAmount;
                    LifeBlob blob = (LifeBlob)lifeInfo.Create(CursedGame);
                    CursedGame.AddGob(blob);
                    CoolDown += Const.LifeSpellCoolDown;
                }
            }
            base.control(info);
        }
        #endregion
    }
}
