﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Cursed.gob.tile;
using Cursed.gob;
using Cursed.gob.mob.kob;
using Microsoft.Xna.Framework.Graphics;

namespace Cursed.ui
{
    public class UINewGameTileInfo : ExitInfo
    {
        public UINewGameTileInfo(int x, int y)
            : base(x, y)
        {
            Level = "Test1";
            this.Texture = "Portal";
            this.Mask = new Color(.2f, .2f, 1f, 1f);
        }

        public override Gob Create(CursedGame game)
        {
            return new UINewGameTile(game, this);
        }
    }

    public class UINewGameTile : Exit
    {
        public UINewGameTile(CursedGame game, UINewGameTileInfo info)
            : base(game, info)
        {
            Inert = false;
            Transcendent = true;
           
        }

        public override void Update(Microsoft.Xna.Framework.GameTime gameTime)
        {
            foreach (Gob gob in TouchedGobs)
            {
                if (gob is UIFamiliar)
                {
                    DruidInfo druidInfo = new DruidInfo();
                    druidInfo.IsPlayer = true;
                    CursedGame.DruidPlayer = (Druid)druidInfo.Create(CursedGame);
                    doWarp();
                    return;
                }
            }
            base.Update(gameTime);
        }
    }
}
