﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Cursed.gob;
using System.Windows;
using Cursed.geom;

namespace Cursed.view
{
    public interface ICamera
    {
        void PushFocus(IFocus focus);
        bool PopFocus(IFocus focus);
        IFocus Focus { get; }

        Matrix Projection { get; }

        Matrix View { get; }

        void updateView(GameWindow window);
        void trackFocus();

        float Zoom { get; set; }

        Bounds Bounds
        {
            get;
        }

        Vector2 Position
        {
            get;
            set;
        }

        Vector3 Position3
        {
            get;
            set;
        }

        float ScreenSize
        {
            get;
        }

        float Aspect
        {
            get;
        }

        float ViewWidth
        {
            get;
        }

        float ViewHeight
        {
            get;
        }
    }
}
