﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Cursed.view
{
    public abstract class Render
    {
        public enum RenderType
        {
            SpriteRender
        }

        protected Effect effect;
        protected RenderInfo info;
        protected GraphicsDevice gd;

        public Render(Effect effect, GraphicsDevice gd)
        {
            this.effect = effect;
            this.gd = gd;
        }

        public void Reposition(OrthoCamera camera)
        {
            effect.Parameters["View"].SetValue(camera.View);
            effect.Parameters["Projection"].SetValue(camera.Projection);
            effect.Parameters["EyePosition"].SetValue(camera.Position3);
        }

        public virtual void Begin(RenderInfo info)
        {
            this.info = info;
            
            effect.Parameters["BasicTexture"].SetValue(info.Texture);
            if (info.Transform != null)
            {
                effect.Parameters["World"].SetValue(info.Transform);
            }
            else
            {
                throw new Exception();
            }
            effect.Begin();

        }

        public void End()
        {
            effect.End();
        }

        public abstract void Draw(GameTime gt, RenderInfo info);
    }
}
