﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;

namespace Cursed.view
{
    public class TextureLib
    {
        private static Dictionary<string, Texture2D> textures = new Dictionary<string, Texture2D>();

        private ContentManager content;

        public TextureLib(ContentManager content)
        {
            this.content = content;
        }

        public Texture2D GetTexture(string assetName)
        {
            try{
                return textures[assetName];
            } catch(KeyNotFoundException){
                textures.Add(assetName, content.Load<Texture2D>("Images\\" + assetName));
            }
            return textures[assetName];
        }

    }
}
