﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using Cursed.input;

namespace Cursed.view.renders
{
    class DialogRenderInfo : RenderInfo
    {
        Vector2 pos;

        public Vector2 Pos
        {
            get { return pos; }
            set { pos = value; }
        }
        String line;

        public String Line
        {
            get { return line; }
            set { line = value; }
        }
       
        public DialogRenderInfo()
        {
            
        }
    }
    class DialogRender :Render
    {
        SpriteFont font;
        CursedGame game;
        OrthoCamera camera;
        public DialogRender(CursedGame game)
            : base(null, null)
        {
            font = game.Content.Load<SpriteFont>("fonts\\console");
            this.game = game;
        }
        public override void Reposition(OrthoCamera camera)
        {
            this.camera = camera;
        }
        public override void Begin(RenderInfo info)
        {
            
            return;
        }
        public override void End()
        {
            return;
        }
        public override void Draw(Microsoft.Xna.Framework.GameTime gt, RenderInfo info)
        {
            DialogRenderInfo i = (DialogRenderInfo)info;
            Vector2 hw = font.MeasureString(i.Line);
            int[] xy = getScreenCoordinates(i.Pos-camera.Position);
            game.SpriteBatch.Begin(SpriteBlendMode.AlphaBlend, SpriteSortMode.Immediate, SaveStateMode.SaveState);
            game.SpriteBatch.Draw(i.Texture, new Rectangle(xy[0]-(int)(hw.X*1.2/2), xy[1]-(int)hw.Y, (int)(hw.X*1.2), (int)(hw.Y)*2), i.Mask);
            game.SpriteBatch.DrawString(font, i.Line, new Vector2(xy[0], xy[1]), Color.White, 0, hw / 2f, 1, SpriteEffects.None, 0);
            game.SpriteBatch.End();
        }
        int[] getScreenCoordinates(Vector2 pos)
        {

            int[] xy = new int[2];
            int windowWidth = game.Window.ClientBounds.Width;
            int windowHeight = game.Window.ClientBounds.Height;
            float viewWidth = camera.ViewWidth;
            float viewHeight = camera.ViewHeight;

            float scaleX = windowWidth/viewWidth;
            float scaleY = windowHeight/viewHeight;

            xy[0] = windowWidth/2 + (int)(pos.X*scaleX+.5);
            xy[1] = windowHeight / 2 + (int)(pos.Y * scaleY * -1 + .5);

            return xy;
        }
    }
}
